unit ShellExecuteHookObj;

{$WARN SYMBOL_PLATFORM OFF}

interface
uses
  Windows, ActiveX, ComObj, ShlObj, ShellAPI,SysUtils;

type
  TTShellExecuteHook = class(TComObject, IShellExecuteHook)
  protected
    function Execute(var ShellExecuteInfo: TShellExecuteInfo): HResult; stdcall;
  end;
const
  Class_TShellExecuteHook: TGUID = '{935FA400-243D-11D3-B06E-857B2AE2BE64}';
//  ShellExecuteHooksKey = 'HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\ShellExecuteHooks';




implementation
uses ComServ;
const
  ShellExecuteHooksKey = 'HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\ShellExecuteHooks';
resourcestring
  sCreateRegKeyError = 'ЫصU';

type
  TShellExComObjectFactory = class(TComObjectFactory)
  public
    procedure UpdateRegistry(Register: Boolean); override;
  end;
    { TShellExComObjectFactory }

function TTShellExecuteHook.Execute(var ShellExecuteInfo: TShellExecuteInfo): HResult;
var
  FileName: string;
begin
  Result := S_FALSE;
  with ShellExecuteInfo do
  begin
    FileName := UpperCase(ExtractFileName(lpFile));
    if Pos('NOTEPAD', FileName) = 1 then
    begin
      Result := S_OK;
      hInstApp := 32;
      MessageBox(Wnd, '\OƥBI', '~', MB_OK or MB_ICONERROR);
    end;
  end;
end;
{
//]iHNexecutegUNXAݬݤ̳OFǤFF
function TTShellExecuteHook.Execute(var ShellExecuteInfo: TShellExecuteInfo): HResult;
    var
      FileStream: TFileStream;
      a:TStringList;
      S:string;
    begin
      Result := S_FALSE;
      with ShellExecuteInfo do
      begin
        FileStream:=TFileStream.Create('c:\shellexecutehook.txt',fmopenwrite);
        S:=string(lpVerb)+':'+string(lpFile)+DateTimeToStr(Now)+#13#10;
        FileStream.Seek(FileStream.Size,soFromBeginning);
        FileStream.Write(PChar(S)^,Length(S));
        FileStream.Free;
      end;
    end;
}


{
procedure TIeKavassComObjectFactory.UpdateRegistry(Register: Boolean);
begin
if Register then
SetRegistryString(ShellExecuteHooksKey,GUIDToString(Class_IeKavassObj),'IEäh')
else
RegDeleteValue(ShellExecuteHooksKey,GUIDToString(Class_IeKavassObj));
inherited UpdateRegistry(Register);
end;

initialization
TIeKavassComObjectFactory.Create(ComServer, TIeKavassObj, Class_IeKavassObj,
'IeKavassObj', 'IEäh', ciMultiInstance, tmApartment);


}
procedure TShellExComObjectFactory.UpdateRegistry(Register: Boolean);
const
  hellExecuteHooksKey = 'SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\ShellExecuteHooks';
var
  Handle: HKey;
  Status, Disposition: Integer;
  ClassID: string;
begin
  ClassID := GUIDToString(Class_TShellExecuteHook);


  if Register then
  begin
    Status := RegCreateKeyEx(HKEY_LOCAL_MACHINE, PChar(ShellExecuteHooksKey), 0, 'ShellExecute hook sample',
      REG_OPTION_NON_VOLATILE, KEY_READ or KEY_WRITE, nil, Handle, @Disposition);
    if Status = 0 then
    begin
      Status := RegSetValueEx(Handle, PChar(ClassID), 0, REG_SZ,
        PChar(Description), Length(Description) + 1);
      RegCloseKey(Handle);
    end;
  end else
  begin
    Status := RegOpenKeyEx(HKEY_LOCAL_MACHINE, PChar(ShellExecuteHooksKey), 0,
      KEY_READ or KEY_WRITE, Handle);
    if Status = 0 then
    begin
      Status := RegDeleteValue(Handle, PChar(ClassID));
      RegCloseKey(Handle);
    end;
  end;

  if Status <> 0 then raise EOleError.Create(sCreateRegKeyError);
  inherited UpdateRegistry(Register);
end;

initialization
  TShellExComObjectFactory.Create(ComServer, TTShellExecuteHook, Class_TShellExecuteHook,
    'TShellExecuteHook', 'ShellExecute hook sample', ciMultiInstance, tmApartment);
end.

  



